<template>

  <div class="q-pl-md rulenode">
    <span>{{ showLabel(rule_node) }}</span>
    <span>parent-child order: {{ rule_node.parent_child_order }}</span>
    <span>Abstract: {{ rule_node.is_abstract }}</span>
    <span>Merge: {{ rule_node.merge }}</span>
    <div class="text-caption">RuleNode</div>

    <RulenodeFormulas :parent="rule_node"></RulenodeFormulas>

    <div class="q-pl-md table__row" v-for="ruleset in rule_node.rulesets"
         v-bind:key="ruleset.rowid">
      <span>Ruleset: {{ ruleset.tag }}</span>
      <RulenodeFormulas :parent="ruleset"></RulenodeFormulas>
      <div class="text-caption">Ruleset</div>
    </div>
    <div v-for="concept_relation in rule_node.concept_relationshipnodes"
         v-bind:key="concept_relation.label" class="q-pl-md table__row">
      {{ showLabel(concept_relation) }} - {{ concept_relation.parent_child_order }} -
      <div class="text-caption">Concept relationship node</div>
    </div>
    <div v-for="dimension_relation in rule_node.dimension_relationshipnodes"
         v-bind:key="dimension_relation.label" class="q-pl-md table__row">
      {{ showLabel(dimension_relation) }} - {{ dimension_relation.parent_child_order }} -
      <div class="text-caption">Dimension relationship node</div>
    </div>

    <div v-for="aspect_node in rule_node.aspect_nodes"
         v-bind:key="aspect_node.label" class="q-pl-md table__row">
      {{ showLabel(aspect_node) }} - {{ aspect_node.parent_child_order }} -
      <div class="text-caption">Aspect node</div>
    </div>

    <div class="q-pl-md" v-if="hasChildren" role="presentation">
      <RuleNode v-for="(child, index) in rule_node.children"
                v-bind:key="index"
                v-bind:rule_node="child">
      </RuleNode>
    </div>
  </div>

</template>

<script>
import SharedMethods from "components/SharedMethods";
import RulenodeFormulas from "components/RulenodeFormulas";

export default {
  name: "RuleNode.vue",
  components: {RulenodeFormulas},
  created() {
    this.label_nice_role = SharedMethods.label_nice_role
    this.get_label = SharedMethods.get_label
  },
  props: {
    rule_node: Object
  },
  data() {
    return {selected: undefined}
  },
  computed: {
    hasChildren: function () {
      return this.rule_node.children && this.rule_node.children.length;
    }
  },
  methods: {
    showLabel: function (node) {
      // get_label fails silently, here we know we don't always have labels, hence fallback
      let label = this.get_label(node)
      if (label.length > 0) {
        return label
      }
      return node.label
    }
  }
}
</script>

<style scoped lang="scss">
.rulenode {
  border: 1px solid $grey-11;
}

.rulenode span {
  display: inline-block;
  padding-right: 10px;
}

.formula {
  background-color: $grey-11;
}
</style>
